#include "stm8l.h"
#include "stm8l_gpio.h"
#include "stm8l_clk.h"

#define PORT GPIOB

#define LED 	GPIO_Pin_1
#define BTN_LED GPIO_Pin_2

#define BTN 	GPIO_Pin_3

static void delay(uint32_t t)
{
	while(t--);
}

uint8_t i, press;
int main( void )
{
	// ---------   GPIO Config ---------------------------

	GPIO_DeInit(PORT);

	GPIO_Init(PORT, LED|BTN_LED, GPIO_Mode_Out_PP_Low_Fast);

	GPIO_Init(PORT, BTN, GPIO_Mode_In_FL_No_IT); // Input floating, no external interrupt

        // ---------- CLK CONFIG -----------------------
        CLK_DeInit();

        CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);

	i=0; press=0;
	for(;;)
  	{
		if(GPIO_ReadInputDataBit(PORT, BTN))
		{
			GPIO_SetBits(PORT, BTN_LED);
			if (press == 0)
			{
  				// Select HSE as system clock source
  				CLK_SYSCLKSourceSwitchCmd(ENABLE);
  				CLK_SYSCLKSourceConfig(CLK_SYSCLKSource_HSE);
  				// system clock prescaler: 1
  				CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);
  				while (CLK_GetSYSCLKSource() != CLK_SYSCLKSource_HSE){};
				press=1;
			}
		} else
			GPIO_ResetBits(PORT, BTN_LED);

    		delay(1000); i++;

		if (i > 50)
		{
			GPIO_ToggleBits(PORT, LED);
			i=0;
		}
  	}
}
