
#include "stm8s.h"
#include "stm8s_gpio.h"
#include "stm8s_clk.h"

#define LED_PORT GPIOB
#define LED GPIO_PIN_5

#define BTN_LED_PORT GPIOC
#define BTN_LED  GPIO_PIN_4

#define BTN_PORT GPIOD
#define BTN GPIO_PIN_2


INTERRUPT_HANDLER(IRQ_Handler_CLK, 2)
{
	CLK_ClearITPendingBit(CLK_IT_CSSD);
        /* Disable CSS interrupt */
	CLK_ITConfig(CLK_IT_CSSD, DISABLE);
}

static void delay(uint32_t t)
{
	while(t--);
}

uint8_t i, press;

ErrorStatus status = FALSE;

int main( void )
{

	// ----------- GPIO CONFIG -------------------
	GPIO_DeInit(LED_PORT);
	GPIO_Init(LED_PORT, LED, GPIO_MODE_OUT_PP_LOW_FAST);

	GPIO_DeInit(BTN_LED_PORT);
	GPIO_Init(BTN_LED_PORT, BTN_LED, GPIO_MODE_OUT_PP_LOW_FAST);

	GPIO_DeInit(BTN_PORT);
	GPIO_Init(BTN_PORT, BTN, GPIO_MODE_IN_FL_NO_IT); // Input floating, no external interrupt


	// ---------- CLK CONFIG -----------------------
	CLK_DeInit();

    	CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV1);
	CLK_SYSCLKConfig(CLK_PRESCALER_HSIDIV1); // set 16 MHz for CPU



	i=0; press=0;
	for(;;)
  	{
		if(GPIO_ReadInputPin(BTN_PORT, BTN))
		{
			GPIO_WriteHigh(BTN_LED_PORT, BTN_LED);
			if (press == 0)
			{
				status = CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, CLK_SOURCE_HSE, DISABLE,
								CLK_CURRENTCLOCKSTATE_DISABLE);
				if (status)
				{
					CLK_ITConfig(CLK_IT_CSSD, ENABLE); // ebanle CLK inteerupt
					CLK_ClockSecuritySystemEnable();

					enableInterrupts();
				}

				press=1;
			}
		} else
			GPIO_WriteLow(BTN_LED_PORT, BTN_LED);

    		delay(1000); i++;

		if (i > 50)
		{
			GPIO_WriteReverse(LED_PORT, LED);
			i=0;
		}
  	}
}
